Page MenuHomePhabricator

Send notification for easy-to-find failed mentions
Closed, ResolvedPublic3 Story Points

Description

Task: If at least one mention failed after a save, send the editor a notification including the failure reasons.
Be aware:

  • If there is more than one mention failure reason per save, the notification has a collapsable part
  • Behind the "..." of the notification is a link to an explanation of mention behavior called "Learn more about mentions"
  • As shown in the screen shots, below is a link, either called "View mentions" or "<the name of the page". In both cases, the link leads to the section where the mentions were made

Screenshots: + Failure reasons to be covered:
Please use the latest text/screenshot version in the comments of F4171034

Background: This task is based on a wish that received 21 points (#9) in the German Community Wishlist[1]. Originally, the wish was to receive an information about the sent messages. To keep the number of notifications smaller, and to help people use mentions in a way that they are sent, the task informs about mention failures, and adds the reasons for the failure as well.

[1] Link to wish (in German): https://de.wikipedia.org/wiki/Wikipedia:Umfragen/Technische_W%C3%BCnsche_2015/Topw%C3%BCnsche#Bei_Speichern_Hinweis_.C3.BCber_abgegebene_Benachrichtigungen_.5BUmfrage_2015.5D
in English: https://meta.wikimedia.org/wiki/WMDE_Technical_Wishes#Notifications_about_failed_mentions

Event Timeline

Lea_WMDE created this task.May 26 2016, 4:07 PM
Lea_WMDE renamed this task from [GTWL] Show mention sucesses/failures for one page in one notification - TASK STILL TO BE DISCUSSED to Send notification for easy-to-find failed mentions.Jun 15 2016, 10:07 AM
Lea_WMDE updated the task description. (Show Details)
Lea_WMDE set the point value for this task to 8.

I edited the task description to reflect the change from displaying positive sent mentions to displaying mention failure

Lea_WMDE updated the task description. (Show Details)Jun 16 2016, 1:28 PM
Lea_WMDE updated the task description. (Show Details)Jun 17 2016, 1:03 PM
WMDE-Fisch claimed this task.

The related patch is almost done. A few questions remain:

The simple checks for an "anonymous" user and an "invalidUser" in the code were a bit misleading.

The invalidUser test checks for invalid symbols in the parsed username. Triggering a failed mention there can be helpful when there is an invisible space in the username. ( e.g. in User​name between User and name ). But it can be misleading because it also triggers when someone tries to link a subpage on the userpage ( e.g. [[User:Fisch/CV]] ). So if we still want failed mentions here we should make sure to have no false positives like that.

The anonymous test filtered unknown users in general. It was not a specific filter for IP users. I added an extra test for IP users in the current version of the patch but I am not sure if it is even possible to get to that point when trying to address an IP user. So this failed mention could be unnecessary.

So in the current version of the patch we have

  • Failed mention for unknown user
  • Failed mention for anonymous IP user
  • Failed mention for over 50 mentions

And could in the future be (hopefully easily) extended to

  • Failed mention for invalid user

I manged to have bundled mentions but am still struggling with the expand / collapse functionality and did not succeed configuring that.

https://gerrit.wikimedia.org/r/#/c/295351/4

Great progress!
We should definitely not trigger mentions with [[User:Fisch/CV]].
To the anonymous user's case: I imagine this in a discussion, where an anon user comments, and somebody wants to reply to them, and links to mention them. But if it makes things much easier, we could also put both cases (not existing / anon) into one error message, such as: "Your mention for "UserX" was not sent because nobody is registered under that name"

I will try to grab Matt today to ask about the collapse functionality.

Change 295351 had a related patch set uploaded (by WMDE-Fisch):
DRAFT Echo notifications for simple mention failures

https://gerrit.wikimedia.org/r/295351

@matej_suchanek reviewed the patch today and pointed me to the patches needed for the collapse functionality. It seemed to me, that it could take some while till they get merged.

I asked myself if we should wait for that or if we want to have the notifications already without expand/collapse or even without bundle at all.

@WMDE-Fisch do you have a link to the patches?

As discussed in the daily I removed bundle related code. We decided on releasing that simple version first. Also removed the draft tag. Please review again. :-)

In today's sprint planning we agreed having mention failures also for invalid user names without triggering them for user subpage links (e.g. User:Testuser/Gadgets).

I don't really understand this conceptually...if a mention notification fails to be sent...we're going to just send another notification telling the user why? Why not add some UI step to allow the user to fix their ping?

If I try to mention someone, but it doesn't work (lets say because I have a typo in the user name), I will receive a notification myself that my intended mention was not sent and why. This is a progress regarding the current situation, where the failure would happen silently. Supporting a user in fixing it would be great. With the approach we are taking, the users will have a link to the page where the failure happened and receive information about the failure reason. Adding another UI step would be out of scope for us right now. If you want to add that, though, please go ahead :)

WMDE-Fisch changed the point value for this task from 8 to 3.

If this is the first task ready to be merged, please make sure T140234 has already been done

What are the next plans for that task? Is it ready to announce? What will be the impact for users?

Change 295351 merged by jenkins-bot:
Echo notifications for mention failures

https://gerrit.wikimedia.org/r/295351

Johan added a subscriber: Johan.Jul 28 2016, 12:21 PM

Will this be in production for all users next week?

WMDE-Fisch added a comment.EditedJul 28 2016, 12:35 PM

Will this be in production for all users next week?

No, there is a global that must be set in the LocalSettings.php to enable the feature on a wiki. For now it will be only active on beta.

Since there are several other tasks and patches addressing mention failure and success notifications we are working on we should wait with activation on other wikis. An announcement can follow when its all done, deployed and enabled.

Lea_WMDE closed this task as Resolved.Aug 16 2016, 1:50 PM